[PATCH] xfstests: 301: sparse copy between different filesystems/mountpoints on btrfs

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



Signed-off-by: Koen De Wit <koen.de.wit@xxxxxxxxxx>
---
301 | 95 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 301.out |    7 ++++
 2 files changed, 102 insertions(+), 0 deletions(-)
 create mode 100644 301
 create mode 100644 301.out

diff --git a/301 b/301
new file mode 100644
index 0000000..05b9b39
--- /dev/null
+++ b/301
@@ -0,0 +1,95 @@
+#! /bin/bash
+# FS QA Test No. 301
+#
+# Check if creating a sparse copy ("reflink") of a file on btrfs
+# expectedly fails when it's done betweeen different filesystems or
+# different mount points of the same filesystem.
+#
+# For both situations, these actions are executed:
+#    - Copy a file with the reflink=auto option.
+#      A normal copy should be created.
+#    - Copy a file with the reflink=always option. Should result in error,
+#      no file should be created.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013, Oracle and/or its affiliates.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+# creator
+owner=koen.de.wit@xxxxxxxxxx
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1    # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+    cd /
+    rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+
+_require_scratch
+_require_cp_reflink
+
+TESTDIR1=$TEST_DIR/test-$seq.$$
+TESTDIR2=$SCRATCH_MNT/test-$seq.$$
+TESTDIR3=$SCRATCH_MNT/test-bis-$seq.$$
+
+mkdir $TESTDIR1
+_scratch_mkfs
+$XFS_IO_PROG -f -c 'pwrite -S 0x61 0 9000' $TESTDIR1/original > /dev/null
+
+_filter_testdirs()
+{
+    sed -e "s,$TESTDIR1,TESTDIR1,g" \
+        -e "s,$TESTDIR2,TESTDIR2,g" \
+        -e "s,$TESTDIR3,TESTDIR3,g"
+}
+
+_create_reflinks_to()
+{
+    mkdir $1
+    cp --reflink=auto $TESTDIR1/original $1/copy
+    md5sum $1/copy | $AWK_PROG 'END {print $1}'
+    rm -rf $1
+    mkdir $1
+ cp --reflink=always $TESTDIR1/original $1/copyfail 2>&1 | _filter_testdirs
+    ls $1/copyfail | wc -l
+}
+
+_scratch_mount
+_create_reflinks_to $TESTDIR2
+_scratch_unmount
+
+mount $TEST_DEV $SCRATCH_MNT
+_create_reflinks_to $TESTDIR3
+umount $SCRATCH_MNT
+
+# success, all done
+status=0
+exit
diff --git a/301.out b/301.out
new file mode 100644
index 0000000..3b66682
--- /dev/null
+++ b/301.out
@@ -0,0 +1,7 @@
+QA output created by 301
+42d69d1a6d333a7ebdf64792a555e392
+cp: failed to clone `TESTDIR2/copyfail' from `TESTDIR1/original': Invalid cross-device link
+0
+42d69d1a6d333a7ebdf64792a555e392
+cp: failed to clone `TESTDIR3/copyfail' from `TESTDIR1/original': Invalid cross-device link
+0
--
1.7.2.5

_______________________________________________
xfs mailing list
xfs@xxxxxxxxxxx
http://oss.sgi.com/mailman/listinfo/xfs


[Index of Archives]     [Linux XFS Devel]     [Linux Filesystem Development]     [Filesystem Testing]     [Linux USB Devel]     [Linux Audio Users]     [Yosemite News]     [Linux Kernel]     [Linux SCSI]

  Powered by Linux